import { NodeInterface, Plugin, SchemaGlobal, PluginOptions, ConversionFromValue, ConversionToValue } from '@aomao/engine';
export interface IndentOptions extends PluginOptions {
    hotkey?: {
        in?: string;
        out?: string;
    };
    maxPadding?: number;
}
export declare const TEXT_INENT_KEY = "text-indent";
export default class<T extends IndentOptions = IndentOptions> extends Plugin<T> {
    static get pluginName(): string;
    init(): void;
    execute(type?: 'in' | 'out'): void;
    queryState(): number | undefined;
    addPadding(block: NodeInterface, padding: number, maxPadding: number): void;
    hotkey(): {
        key: string;
        args: string;
    }[];
    schema(): SchemaGlobal;
    conversion(): Array<{
        from: ConversionFromValue;
        to: ConversionToValue;
    }>;
    onBackspace: (event: KeyboardEvent) => false | undefined;
    onTab: (event: KeyboardEvent) => false | undefined;
    onShiftTab: (event: KeyboardEvent) => false | undefined;
    convertToPX(value: string): string;
    pasteEach: (node: NodeInterface) => void;
    destroy(): void;
}
