'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var engine = require('@aomao/engine');

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

var TEXT_INENT_KEY = 'text-indent';

var _default = /*#__PURE__*/function (_Plugin) {
  _inherits(_default, _Plugin);

  var _super = _createSuper(_default);

  function _default() {
    var _this;

    _classCallCheck(this, _default);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.onBackspace = function (event) {
      if (!engine.isEngine(_this.editor)) return;
      var _this$editor = _this.editor,
          change = _this$editor.change,
          list = _this$editor.list,
          node = _this$editor.node;
      var blockApi = _this.editor.block;
      var range = change.range.get();

      var block = _this.editor.block.closest(range.startNode);

      if (!node.isBlock(block)) return;
      var parent = block.parent();
      var blocks = change.blocks;

      if (parent && node.isBlock(parent)) {
        blocks = blocks.filter(function (b) {
          return !b.equal(parent);
        });
      }

      if ('li' === block.name) {
        if (range.collapsed && !list.isFirst(range)) {
          return;
        } else if (!range.collapsed) return;
      } else if ((range.collapsed && blockApi.isLastOffset(range, 'end') || !blockApi.isFirstOffset(range, 'start')) && !node.isEmptyWidthChild(block) || blocks.length > 1) return;else if (!range.collapsed) return;

      if (_this.queryState()) {
        event.preventDefault();

        _this.editor.command.execute(_this.constructor.pluginName, 'out');

        return false;
      }

      return;
    };

    _this.onTab = function (event) {
      if (!engine.isEngine(_this.editor)) return;
      var _this$editor2 = _this.editor,
          change = _this$editor2.change,
          list = _this$editor2.list,
          block = _this$editor2.block;
      var range = change.range.get(); //列表

      if (range.collapsed && list.isFirst(range)) {
        event.preventDefault();

        _this.editor.command.execute(_this.constructor.pluginName, 'in');

        return false;
      } // <p><cursor />foo</p>


      if (!range.collapsed || block.isFirstOffset(range, 'start')) {
        event.preventDefault();

        _this.editor.command.execute(_this.constructor.pluginName, 'in', true);

        return false;
      }

      return;
    };

    _this.onShiftTab = function (event) {
      if (!engine.isEngine(_this.editor)) return;
      event.preventDefault();

      _this.editor.command.execute(_this.constructor.pluginName, 'out');

      return false;
    };

    _this.pasteEach = function (node) {
      //pt 转为px
      if (node.isElement() && !node.isCard() && _this.editor.node.isBlock(node)) {
        var styles = node.css();
        var textIndentSource = styles[TEXT_INENT_KEY];

        if (!!textIndentSource && textIndentSource.endsWith('pt')) {
          var textIndent = _this.convertToPX(textIndentSource);

          if (!!textIndent) {
            var maxPadding = _this.options.maxPadding || 50;
            var newValue = engine.removeUnit(textIndent); // 获取自身宽度计算最大的indent

            var width = node.width();
            width = width === 0 ? _this.editor.root.width() : width; // 获取字体大小用作计算em

            var fontSize = node.css('font-size'); // 如果本身没有字体大小就，获取编辑器根节点默认字体大小

            fontSize = !fontSize || fontSize.endsWith('em') ? _this.editor.root.css('font-size') : fontSize;

            if (fontSize.endsWith('em')) {
              fontSize = engine.$(document.body).css('font-size');
            }

            if (!fontSize.endsWith('px')) fontSize = '16px';
            var widthMax = width > 0 ? width / engine.removeUnit(fontSize) : maxPadding;
            newValue = Math.min(textIndent.endsWith('px') ? newValue / engine.removeUnit(fontSize) : newValue, maxPadding, widthMax);
            if (newValue <= 0) node.css(TEXT_INENT_KEY, '');else {
              node.css(TEXT_INENT_KEY, engine.addUnit(newValue > 0 ? newValue : 0, 'em'));
            }
          }
        }
      }
    };

    return _this;
  }

  _createClass(_default, [{
    key: "init",
    value: function init() {
      var _this2 = this;

      this.editor.schema.add(this.schema());
      this.conversion().forEach(function (_ref) {
        var from = _ref.from,
            to = _ref.to;

        _this2.editor.conversion.add(from, to);
      });
      this.editor.on('keydown:backspace', this.onBackspace);
      this.editor.on('keydown:tab', this.onTab);
      this.editor.on('keydown:shift-tab', this.onShiftTab);

      if (engine.isEngine(this.editor)) {
        this.editor.on('paste:each', this.pasteEach);
      }
    }
  }, {
    key: "execute",
    value: function execute() {
      var _this3 = this;

      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'in';
      if (!engine.isEngine(this.editor)) return;
      var _this$editor3 = this.editor,
          change = _this$editor3.change,
          list = _this$editor3.list,
          block = _this$editor3.block;
      list.split();
      var range = change.range.get();
      var blocks = block.findBlocks(range); // 没找到目标 block

      if (!blocks) {
        return;
      }

      var maxPadding = this.options.maxPadding || 50; // 其它情况

      blocks.forEach(function (block) {
        _this3.addPadding(block, type === 'in' ? 2 : -2, maxPadding);
      });
      list.merge();
    }
  }, {
    key: "queryState",
    value: function queryState() {
      if (!engine.isEngine(this.editor)) return;
      var _this$editor4 = this.editor,
          change = _this$editor4.change,
          list = _this$editor4.list,
          node = _this$editor4.node;
      var range = change.range.get();
      if (!range.startNode.inEditor()) return 0;
      var block = this.editor.block.closest(range.startNode);

      if (block.name === 'li') {
        return list.getIndent(block.closest('ul,ol'));
      }

      if (node.isRootBlock(block) || node.isNestedBlock(block)) {
        return engine.removeUnit(block.css(TEXT_INENT_KEY));
      }

      return 0;
    }
  }, {
    key: "addPadding",
    value: function addPadding(block, padding, maxPadding) {
      var _this$editor5 = this.editor,
          list = _this$editor5.list,
          node = _this$editor5.node;
      if (block.name === 'li') return;

      if (node.isList(block)) {
        list.addIndent(block, padding, maxPadding);
      } else if (node.isRootBlock(block) || node.isNestedBlock(block)) {
        if (padding > 0) {
          if (engine.removeUnit(block.css(TEXT_INENT_KEY))) {
            var currentValue = block.css(TEXT_INENT_KEY);
            var newValue = engine.removeUnit(currentValue) + padding; // 获取自身宽度计算最大的indent

            var width = block.width();
            width = width === 0 ? this.editor.root.width() : width; // 获取字体大小用作计算em

            var fontSize = block.css('font-size'); // 如果本身没有字体大小就，获取编辑器根节点默认字体大小

            fontSize = !fontSize || fontSize.endsWith('em') ? this.editor.root.css('font-size') : fontSize;

            if (fontSize.endsWith('em')) {
              fontSize = engine.$(document.body).css('font-size');
            }

            if (!fontSize.endsWith('px')) fontSize = '16px';
            var widthMax = width > 0 ? width / engine.removeUnit(fontSize) : maxPadding;
            newValue = Math.min(currentValue.endsWith('px') ? newValue / engine.removeUnit(fontSize) : newValue, maxPadding, widthMax);
            if (newValue <= 0) block.css(TEXT_INENT_KEY, '');else {
              block.css(TEXT_INENT_KEY, engine.addUnit(newValue > 0 ? newValue : 0, 'em'));
            }
          } else {
            block.css(TEXT_INENT_KEY, "".concat(padding, "em"));
          }
        } else {
          var _currentValue = block.css(TEXT_INENT_KEY);

          var _newValue = engine.removeUnit(_currentValue) + padding;

          if (_newValue <= 0) block.css(TEXT_INENT_KEY, '');else {
            block.css(TEXT_INENT_KEY, engine.addUnit(_newValue > 0 ? _newValue : 0, 'em'));
          }
        }
      }
    }
  }, {
    key: "hotkey",
    value: function hotkey() {
      var _this$options$hotkey, _this$options$hotkey2;

      var inHotkey = ((_this$options$hotkey = this.options.hotkey) === null || _this$options$hotkey === void 0 ? void 0 : _this$options$hotkey.in) || 'mod+]';
      var outHotkey = ((_this$options$hotkey2 = this.options.hotkey) === null || _this$options$hotkey2 === void 0 ? void 0 : _this$options$hotkey2.out) || 'mod+[';
      return [{
        key: inHotkey,
        args: 'in'
      }, {
        key: outHotkey,
        args: 'out'
      }];
    }
  }, {
    key: "schema",
    value: function schema() {
      return {
        type: 'block',
        attributes: {
          style: _defineProperty({}, TEXT_INENT_KEY, '@length')
        }
      };
    }
  }, {
    key: "conversion",
    value: function conversion() {
      var _this4 = this;

      return [{
        from: function from(_, styles, attributes) {
          return !!styles['padding-left'] || !!attributes[TEXT_INENT_KEY];
        },
        to: function to(name, styles, attributes) {
          var node = engine.$("<".concat(name, " />"));
          var valueStr = styles['padding-left'] || attributes[TEXT_INENT_KEY]; // 转换为px

          if (valueStr.endsWith('pt')) {
            valueStr = _this4.convertToPX(valueStr);
          } // 转换为em


          if (valueStr.endsWith('px')) {
            // 获取自身的字体大小
            var fontSize = styles['font-size']; // 如果本身没有字体大小就，获取编辑器根节点默认字体大小

            fontSize = !fontSize || fontSize.endsWith('em') ? _this4.editor.root.css('font-size') : fontSize;

            if (fontSize.endsWith('em')) {
              fontSize = engine.$(document.body).css('font-size');
            }

            if (!fontSize.endsWith('px')) fontSize = '16px';
            var value = engine.removeUnit(valueStr) / engine.removeUnit(fontSize);
            styles[TEXT_INENT_KEY] = "".concat(value, "em");
          } else if (valueStr.endsWith('em')) {
            styles[TEXT_INENT_KEY] = valueStr;
          }

          delete styles['padding-left'];
          delete attributes[TEXT_INENT_KEY];
          node.css(styles);
          Object.keys(attributes).forEach(function (name) {
            node.attributes(name, attributes[name]);
          });
          return node;
        }
      }];
    }
  }, {
    key: "convertToPX",
    value: function convertToPX(value) {
      var match = /([\d\.]+)(pt|px)$/i.exec(value);

      if (match && match[2] === 'pt') {
        return String(Math.round(parseInt(match[1], 10) * 96 / 72)) + 'px';
      }

      return value;
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.editor.off('keydown:backspace', this.onBackspace);
      this.editor.off('keydown:tab', this.onTab);
      this.editor.off('keydown:shift-tab', this.onShiftTab);

      if (engine.isEngine(this.editor)) {
        this.editor.off('paste:each', this.pasteEach);
      }
    }
  }], [{
    key: "pluginName",
    get: function get() {
      return 'indent';
    }
  }]);

  return _default;
}(engine.Plugin);

exports.TEXT_INENT_KEY = TEXT_INENT_KEY;
exports.default = _default;
